v3.4.5 (2026-08-23)

 * \DTLifhaskey : true and false arguments now allow paragraph breaks

 * \DTLmaprow and \dtlmapcurrentrow: body argument now allows paragraph breaks

v3.4.4 (2026-07-31)

 * bug fix: corrected misspelt command in datatool-latin1.ldf
   https://www.dickimaw-books.com/bugtracker.php?key=318

v3.4.3 (2025-12-04)

 * bug fix: error occurs when datatool.sty loaded separately after
   datatool-base.sty has been loaded.

v3.4.2 (2025-11-06)

 * corrected some expl3 declaration errors

v3.4.1 (2025-04-25)

 * databib.sty:

  - bug fix: incorrect arguments in \__datbib_get_year_suffix:n
    https://www.dickimaw-books.com/bugtracker.php?key=303

v3.4 (2025-04-03)

 * datatool-base:

  - bug fix: sci regex needs to be anchored
    https://www.dickimaw-books.com/bugtracker.php?key=301

  - bug fix: columns identified as string in data-types shouldn't
    have items parsed (csv-content=tex or csv-content=literal)

v3.3 (2025-03-25)

 * datatool:

   - bug fix: Missing cell content when reading CSV file when more
     than one instance of separator found in delimited cell.
     https://www.dickimaw-books.com/bugtracker.php?key=299

v3.2 (2025-03-14)

 * datatool-base:

   - added \datatool_sort_preprocess:NnN

 * datatool:

   - \DTLread : added csv-content=no-parse option

v3.1 (2025-03-10)

 - Bug fix: commands like \DTLmeanforkeys are not expanding the result
   before formatting, which is causing a "Can't convert" warning.
   https://www.dickimaw-books.com/bugtracker.php?key=290

 - added \datatool_warn_not_number:n

 - correct warn if not number for \DTLdecimaltocurrency

v3.0.1 (2025-03-05):

Adding missing ldf, def and rollback files to datatool.tds.zip

v3.0 (2025-03-03):

Major new released. Rollback to v2.32 provided.

  * datatool-base.sty:

    - new package options: nolocale, locales (synonym lang),
      lang-warn

    - new values for 'math' option: lua and l3fp. The default is now lua for
      LuaLaTeX and l3fp otherwise. Processor files are now called 
      datatool-<processor>.def and old datatool-fp.sty and datatool-pgfmath.sty 
      files are now stubs that generate a warning and load the 
      applicable .def file

    - support for scientific notation

    - new plain number commands: 
        \dtladdall, \dtlmeanforall,
        \dtlminall, \dtlmaxall
      (Counterparts to formatted number commands \DTL...)

    - no longer loads substr.sty

    - optional argument added to \DTLdecimaltocurrency 

    - added support for datum markers

      \DTLparse
      \DTLxparse
      \DTLusedatum
      \DTLdatumvalue
      \DTLdatumcurrency
      \DTLdatumtype
      \DTLsetintegerdatum, \DTLxsetintegerdatum
      \DTLsetdecimaldatum, \DTLxsetdecimaldatum, \DTLsetfpdatum
      \DTLsetcurrencydatum, \DTLxsetcurrencydatum
      \DTLsetstringdatum, \DTLxsetstringdatum

    - optional parsing for dates and times (still experimental)

    - new commands:

      \DTLifEndsWith
      \DTLifiSubString, \DTLisiPrefix, \DTLisSuffix, \DTLisiSuffix
      \DTLisnumlt, \DTLisnumgt, \DTLisnumlteq, \DTLisnumgteq
      \DTLStoreInitialGetLetter, \DTLinitialpunc, \DTLaposinitialpunc
      \DTLGetInitialLetter, \ifDTLGetInitialLetterPurifyEarly
      \DTLCurrentLocaleGetInitialLetter
      \datatoolparen
      \dtlpadleadingzeros, \dtlpadleadingzerosminus, \dtlpadleadingzerosplus

    - Made fragile commands robust

    - New command \DTLsortwordlist as a more efficient alternative
      to \dtlsortlist, with handler commands:
      \DTLsortwordhandler, \DTLsortwordcasehandler,
      \DTLsortletterhandler, \DTLsortlettercasehandler

    - new options:

      initial-purify:

      Governs when purification takes place for \DTLGetInitialLetter

      auto-reformat-types:

      Governs which data types should be reformatted if the
      applicable auto-reformat option is on.

      lists/trim:

      If true (default), leading and trailing spaces are now trimmed around
      comma-separated list elements
      **Note** this changes the default behaviour. Use
      \DTLsetup{ lists = { trim = false } } to prevent this.

      lists/sort-reverse:

      If true, \DTLsortwordlist and \dtlsortlist will sort in reverse
      order.

      compare/expand-cs:

      If true, \dtlcompare and \dtlicompare fully expand their
      string arguments

      numeric:

      Governs numeric settings.

      datetime:

      Governs date and time settings.

    - The following commands have been rewritten using LaTeX3:

      \dtlwordindexcompare
      \dtlletterindexcompare
      \dtlcompare
      \dtlicompare
      \DTLifinlist
      \DTLlistelement
      \DTLfetchlistelement
      \DTLnumitemsinlist
      \dtlsortlist
      \dtlinsertinto
      \DTLifStartsWith
      \DTLifSubString
      \DTLstoreinitials, \DTLinitials

    This may produce different results and different build speeds,
    but in general it should make an improvement. If any problems
    occur use rollback.

   - added starred version of dtlenvgforint environment

   - bug fix: \DTLgclip should only take two arguments

   - bug fix: \dtlparsewords undefined control sequence \dlt@parsewordshandler

   - bug fix: \DTLifStartsWith doesn't ignore commands as documented

  * datatool.sty:

   - new 'global' option now determines whether or not commands like
     \DTLnewdbentry have a local or global effect. (Defining a 
     new database is always global.)

     NB the default is global=true which is more consistent over all
     commands but means that some commands which previously had a
     local effect may now be global. Use \DTLsetup{global=false}
     to revert.

   - new 'store-datum' option provided to reduce parsing of data.

   - new save/load commands: \DTLwrite and \DTLread
     (old save/load commands rewritten to use the applicable new one)

   - new general purpose \DTLaction and associated commands \DTLget
     and \DTLuse.

   - most commands have been rewritten in \LaTeX3

   - fragile commands have been made robust

   - \DTLdisplaydb and \DTLdisplaylongdb have been rewritten to 
     construct the tabular content in a token list, which 
     removes the loop from the body of the tabular / longtable environment.

   - cs=key assignment list commands now trim leading and trailing spaces

   - \DTLiflastrow takes filtering into account

   - new mapping (loop) commands: \DTLmapdata and \DTLmaprow 

     \DTLmapdata is an alternative to DTLforeach that only performs local
     assignments. Not suitable for use within tabular-like environments
     (unless restricted to the content of a single cell)

   - new commands:

     \DTLsortdata (alternative to \dtlsort)
     \DTLassignfromcurrentrow

  * datatool-pgfmath.def:

   - bug fix: \dtlroot should take three arguments

  * datapie.sty:

   - mostly rewritten in LaTeX3.

   - removed dependency on xkeyval (switched to l3keys)

   - extra options in key=value interface (instead of using
     \setlength, setcounter etc)

   - new hook: \DTLpieatsegment

   - \DTLpiechart may now have an empty database name argument
     to indicate the default database.

  * databar.sty

   - mostly rewritten in LaTeX3.

   - removed dependency on xkeyval (switched to l3keys)

   - extra options in key=value interface (instead of using
     \setlength, setcounter etc)

   - \DTLbarchart and \DTLmultibarchart may now have an empty
     database name argument to indicate the default database.

   - bar charts may be created using new action command

   - new hooks and settings:

     \DTLbarXupperlabelalign
     \DTLbarXneglabelalign
     \DTLbarXnegupperlabelalign
     \DTLtotalbars
     \DTLbartotalvariables
     \DTLtotalbargroups
     \DTLbarindex
     \DTLbargroupindex
     \DTLyAxisLabelStyle
     \DTLbargrouplabelalign
     \DTLBarStyle
     \DTLdisplaybargrouplabel
     \DTLclearbarcolors
     \DTLclearnegbarcolors
     \DTLgetnegbarcolor
     \DTLeveryprebarhook
     \DTLeverybargrouphook
     \DTLbarsetupperlabelalign

  * dataplot.sty:

   - mostly rewritten in LaTeX3.

   - extra options in key=value interface

   - the x and y settings may take a comma-separated list of
     column keys to allow multiple x/y pairs from the same database

   - bug fixes

   - legend setting now has extra 'custom' option which uses
     new command \DTLcustomlegend (redefine as required)

   - other new commands including:

    \DTLplotdisplayXticklabel
    \DTLplotdisplayYticklabel
    \DTLplotlegendxy
    \DTLplotlegendxysep
    \DTLplotlegendnamesep
    \DTLplotlegendname
    \DTLplotlegendsetname
    \DTLplotlegendx
    \DTLplotlegendsetxlabel
    \DTLplotlegendy
    \DTLplotlegendsetylabel

  * databib.sty

   - mostly rewritten in LaTeX3.

   - removed dependency on xkeyval (switched to l3keys)

   - \DTLbibliography, \DTLcomputewidestbibentry and
     \DTLmbibliography switched to read-only loops

   - various commands made robust

   - corrected local assignments in \DTLforeachbibentry

   - end of sentence test now also checks for ! and ?

   - new style hook commands: 
     \DTLpostvon, \DTLpostvolnum, \DTLpostpagename, 
     \DTLpostvolumename, \DTLpostchaptername,
     \DTLpostnumbername, \DTLprecite, \DTLofseries,
     \DTLofseriesfmt, \DTLinseries, \DTLjournalfmt,
     \DTLinbooktitlefmt, \DTLmanualtitlefmt,
     \DTLthesistitlefmt, \DTLproceedingstitlefmt,
     \DTLresetpredefined, \DTLresetpredefinedabbrv

   - \DTLmonthname will now use datetime2.sty commands if available.

   - new commands to assist sorting author/editor lists with
     \DTLsortdata:
     \DTLbibsortencap, \DTLbibsortname, \DTLbibsortnamesep

   - added localisation support.

   - Bug fix: \DTLaddperiod insert period before resetting
     conditionals

  * person.sty:

    - mostly rewritten in LaTeX3.

    - new package options: base-only, datatool and shortcuts

    - sentence case now uses LaTeX3.

    - starred version of \newperson with key=value interface.

    - added support for title, forenames and surname with hooks to
      allow supplementary packages to add support for extra data.

    - added non-binary and unknown.

    - added localisation support.

    - the following commands are now deprecated:

      \addmalelabel (use \PersonAddMaleLabel instead)
      \addfemalelabel (use \PersonAddFemaleLabel instead)
      \ifmalelabel (use \PersonIfMaleLabel instead)
      \iffemalelabel (use \PersonIfFemaleLabel instead)
      \ifmale (use \PersonIfMale instead)
      \ifallmale (use \PersonIfAllMale instead)
      \iffemale (use \PersonIfFemale instead)
      \ifallfemale (use \PersonIfAllFemale instead)

    - the following commands have been renamed:

      \malelabels -> \g_person_male_label_clist
      (use \PersonSetMaleLabels or \PersonAddMaleLabel to change the list)
      \femalelabels -> \g_person_female_label_clist
      (use \PersonSetFemaleLabels or \PersonAddFemaleLabel to change the list)

    - removed counter 'person'

    - various new commands

v2.32 (2019-09-27):

  * datagidx.sty:

   - added check for new 2019/10/01 LaTeX kernel when defining
     \datagidxstripaccents.

    ** Pre version 2.32 accent stripping in \newterm won't work with new LaTeX kernel. **

  * datatool-base.sty:

   - added \ifdtlcompareskipcs
     (see https://www.dickimaw-books.com/bugtracker.php?action=view&key=99)

   - bug fix (\dtlcompare not finding word breaks)
     (https://www.dickimaw-books.com/bugtracker.php?action=view&key=100)

   - bug fix (error if first command in assignment list is equal to \relax)
     (https://www.dickimaw-books.com/bugtracker.php?action=view&key=106)

   - bug fix (removed \relax from definitions of \DTLiffirstrow and \DTLiflastrow)
     (https://www.dickimaw-books.com/bugtracker.php?action=view&key=130)

v2.31 (2018-12-07):

  * datatool-base.sty:

   - added conditional \ifDTLlistskipempty

   - new commands \DTLlistelement and \DTLfetchlistelement

   - made \DTLnumitemsinlist robust and now checks 
     \ifDTLlistskipempty

   - \DTLformatlist now checks \ifDTLlistskipempty

   - bug fix: \$ entry without value triggers 
     extra \else in \@dtl@checknumericalstart

v2.30 (2018-04-16):

  * datatool.sty

   - bug fix: spurious spaces in \@dtl@lopoff 
    (used by \DTLloaddb and DTLloadrawdb)

v2.29 (2017-11-12):

  * datatool.sty:

   - bug fix https://tex.stackexchange.com/questions/400921

v2.28 (2017-11-10):

  * datatool.sty:

   - added \xdtlgetrowindex

   - \DTLloadrawdb: changed \xdef to \protected@xdef

   - some bug fixes

  * datatool-base.sty:

   - added \DTLformatlist and accompanying commands
     \DTLlistformatsep, \DTLlistformatoxford, \DTLlistformatlastsep,
     \DTLandname and \DTLlistformatitem.

  * datagidx.sty:

   - changed initialisation of label in \datagidx@setfieldvalues

   - \datagidxstripaccents now changes \add@accent@, 
     \@text@composite@x and \@tabacckludge

   - added \datagidxextendedtoascii

   - \printterms uses \twocolumn if balance=false and columns=2

v2.27 (2016-07-28):

  * datatool-base:

   - reverted \dtl@insertinto to pre v2.26. (The bug fixes
     in v2.26 caused backward-compatibility issues, which 
     break glossaries.sty's "noidx" code.)

   - new commands \dtlsortlist and \dtlinsertinto (which
     are how \dtl@sortlist and \dtl@insertinto ought to
     behave but don't). The internal commands are left for
     backward compatibility. The user commands should be
     used for the correct function. (Added new section in
     the user manual documenting these new commands.)

   - new command \edtlinsertinto

v2.26 (2016-07-20):

  * datatool-base:

    - fixed bug in \dtl@insertinto

  * datatool-pgfmath:

    - fixed bug in \dtlround and \dtltrunc

  * datapie:

    - fixed bug in \DTLpiechart caused by truncation error

    - \FP... code replaced by \dtl... code

v2.25 (2016-01-18):

  * datatool-base:

    - \dtlcompare, \dtlicompare, \@dtldictcompare:
      added \expandonce to definitions of \dtl@donext to
      prevent unwanted expansion of non-ASCII characters.

  * datatool user guide:

    - Added section "Advanced Iteration".

v2.24 (2016-01-12):

  * datatool-base:

    - added "utf8" package option and \dtlenableUTFviii, 
      \dtldisableUTFviii

    - added \dtlsetcharcode, \dtlsetlccharcode,
      \dtlsetUTFviiicharcode, \dtlsetUTFviiilccharcode
      \dtlsetdefaultUTFviiicharcode and
      \dtlsetdefaultUTFviiilccharcode for use with the comparison
      handlers.

v2.23 (2015-07-11):

  * datatool:

    - etex no longer loaded.

    - added \DTLisinlist and \DTLmaketabspace

    - Bug fix (\@dtl@starttrim): fixed issue that caused 
      loss of group at the start of a line when reading a csv file 

    - Bug fix: unstarred (case-sensitive) version of \DTLsort
      now correctly uses case-sensitive sort.

    - Bug fix: error in \DTLifSubString

  * person:

    - Bug fix: replaced \ifpersonmale with \ifmale within the
      definitions of \persongender and \getpersongender

    - Bug fix: replaced \@thisperson with #1 in \ifmale and
      \iffemale

v2.22 (2014-06-10):

  * datatool-base:

   - Bug fix: removed \@dtl@choptrailingzeroes from
     \@dtl@decimaltolocalefrac (interfering with \DTLround)

  * datatool:

   - added "autokeys" option to \DTLloaddb and \DTLloadrawdb

  * databib:

   - new commands: \DTLbibfieldlet, \DTLformatthisbibentry,
     \DTLpcite, \DTLcustombibitem, \DTLformatbooktitle



v2.21 (2014-03-08):

  * datatool:

    - Fixed misplaced locations of \dtldisplaystarttab and
    \dtldisplayafterhead within \DTLdisplaylongdb

    - Fixed bug in \dtl@gathervalues that ignored #3

  * databib:

    - Added \gDTLforeachbibentry

    - Fixed bug in \DTLforeachbibentry*

    - fixed typo in documentation
      \DTLforeachbib -> \DTLforeachbibentry

  * datagidx:

    - Fixed bug in \datagidx@parse@location

v2.20 (2014-02-03):

  * datatool:

   - added \DTLloaddbtex

   - added \DTLifnullorempty

   - added \DTLassignfirstmatch and \xDTLassignfirstmatch

   - Fixed bug in \DTLforeach* (\@dtl@dbname undefined)

v2.19 (2014-01-17):

  * datatool:

   - changed \\ to \dtldisplaycr in \DTLdisplaydb
     and set \dtldisplaycr to \tabularnewline

   - fixed bug in \glsaddall

  * datagidx:

   - added \glslink

   - defines \@idxitem if not already defined

v2.18 (2013-09-06):

  * datatool:

   - added check in \dtlsort for existence of specified keys 

   - reverted \DTLpar back to a robust command instead of using \let


  * databib.bst:

    Fixed error caused when article entry journal field missing

v2.17 (2013-08-29):

 * datatool:

   - added \edtlgetrowforvalue and \DTLfetch

   - added joining two databases in a single table example to user manual

 * databib:

   - fixed packaging of databib.bst

v2.16 (2013-08-16):

 * datatool:

  - Fixed bug in \@dtl@updatekeys that causes an error when the 
    data contains fragile commands.

 * datatool-base:

  - Fixed bug in \@dtl@checknumerical that causes an error when the
    argument is a command that expands to empty.


v2.15 (2013-07-10):

 * datagidx:

  - Removed spurious space in \do@locrange

  - Added \loadgidx

  - Added nowarn package option

  - Fixed bug that occurred with locations occurring in
    page-spanning paragraphs.

 * datatool:

  - added \dtllastloadeddb to \DTLsaverawdb etc

  - fixed bug that caused \DTLsaverawdb to perform extremely slowly.
    Now provide \DTLprotectedsaverawdb to save databases that contain
    fragile commands.

  - fixed bug in \DTLminforkeys

 * dataplot:

  - added \dtlplothandlermark 

  - fixed scoping issue with \DTLaddtoplotlegend

v2.14 (2013-06-28):

 * datatool:

  - fixed bug in \@dtl@updatekeys
    (Bug report: http://www.dickimaw-books.com/cgi-bin/bugtracker.cgi?action=view&key=20)

  - fixed \DTLsaverawdb so that it works when there are fragile
    commands in database entries


 * dataplot:

  - refactored \DTLplot to help prevent large data values exceeding
    TeX's maximum dimensions

  - aded tikz calc library as a requirement

 * datagidx:

  - added 'condition' key to \printterms

  - added \postnewtermhook, \newtermfield, \ifnewtermfield,
    \datagidxdb

  - fixed bug in 'gloss' style that displayed multiple "see also"
    lines for entries that have children.

 * Fixed minor typos in user manual

v2.13 (2013-01-15):

 * Added new package `datagidx'

   - create glossaries/indexes /without/ using an external tool such
     as makeindex or xindy

 * datatool.sty

  - added \dtlsort (like \DTLsort but user supplies custom
    comparison handler).

  - added \DTLgnewdb, \DTLgdeletedb, \DTLgcleardb

  - added \DTLsaverawdb

  - added \ifDTLnewdbonload, \DTLnewdbonloadtrue,
    \DTLnewdbonloadfalse

  - added \dtlparsewords

  - fixed bug in \@DTLnewrow (misspelt \PackageError command)

  - removed spurious space in \@dtl@setheaderforindex

  - removed spurious space in \DTLaddentryforrow

  - removed spurious space in \DTLdisplaydb and \DTLdisplaylongdb

  - removed spurious space in \@dtl@getsortdirection

  - removed spurious space in \@dtl@readline

  - removed spurious space in \DTLrawmap

  - \dtl@setcharcode and \dtl@setlccharcode now check 
    for \@dtl@wordbreak instead of space and tilde

  - \dtl@setlccharcode bug fix (characters without a lowercase
    now correctly dealt with)

  - \dtlicompare and \dtl@teststartswith now use 
    \dtl@setwordbreaksnohyphens to deal with spaces

  - added \@dtlstringnull and \@dtlnumbernull and fixed bug in
    \DTLifnull

  - renamed datatool.pdf to datatool-code.pdf

 * datatool-base.sty

  - added \dtlwordindexcompare

v2.12 (2012-11-30):

 * datatool.sty:

   - fixed bug in \DTLiflastrow

   - Fixed bug causing spurious space in \DTLloaddb


 * datatool-pgfmath.sty:

   - fixed bug in conditionals.

v2.11 (2012-09-25):

 * datatool.sty:

   - removed unwanted space in \@dtl@updatekeys

   - fixed typo in user guide (should be \dtlforcolumnidx not
     \dtlforcolumnindex)

   - added \dtldisplayvalign

   - added \DTLaddcolumn

   - added \dtlgetrowforvalue

   - added \dtlupdateentryincurrentrow

   - added \DTLgetrowindex and \dtlgetrowindex

v2.10 (2012/07/18):

 * datatool.sty:

   - Split package into datatool-base.sty, datatool-fp.sty and
     datatool-pgfmath.sty

   - Added package option "math" (math=fp -> use fp.sty,
     math=pgfmath -> use pgfmath.sty)

   - datatool.sty now requires etoolbox (changed commands like 
     \@ifundefined to etoolbox equivalents)

   - Added 'omitlines' option when loading csv file (from patch supplied by Bruno Le Floch
     at:
     http://tex.stackexchange.com/questions/22942/skipping-the-first-line-of-a-data-file-for-pgfplotstable/25133#25133 )

   - \DTLloaddb : adds default column header if missing

   - Added optional argument to \DTLdisplaydb

   - Added omit key to \DTLdisplaylongdb

   - added environment dtlenvgforint

   - added environments DTLenvforeach and DTLenvforeach*

   - added check for at least version 1.2 (2009/10/20) of substr.sty

   - added \DTLassign

   - added DTLnumitemsinlist

   - added \dtlrecombine, \dtlrecombineomitcurrent,
     \dtlreplaceentryincurrentrow, \dtlswapentriesincurrentrow,
     \dtlremoveentryincurrentrow, \dtlappendentrytocurrentrow

   - Rewritten \@dtl@ifDigitOrDecimalSep (code provided by Bruno Le Floch)

   - ensured first argument of \DTLconverttodecimal gets one-level
     expansion in commands like \DTLaddall

   - Fixed \DTLloaddb to work if % used at the start of a row in CSV file.

   - Fixed \@dtl@qlopoff to substitute escaped CSV delimiters

   - Fixed bug in \DTLloadrawdb, which only performed a single
     substitution per line

   - Added \long before \edef in \DTLsubstituteall

   - Fixed bug in \@dtl@getkeyforcolumn (affects
     \DTLgetkeyforcolumn)

   - Changed tab character to ^^I

   - Fixed bug in \DTLloaddb and \DTLloadrawdb when CSV file only contains one column

 * databib.bst:

   - Added eprints field

 * datatool-user.tex (User guide):

   - fixed typo "\value{DTLbibrow}<11" => "\value{DTLbibrow}<10"

   - added section "Operating on Current Row"

   - added remark on using etoolbox to check for empty values

v2.03 (2009/11/15):
 * Added facility to clear or delete a database.

 * Fixed bug in \DTLsavedb that prints duplicate information to file.

 * \DTLreplaceentryforrow expands the replacement value 

 * \DTLappendtorow expands the new value 

 * \DTLnewdbentry : user can choose between expanding or not 
   expanding value before adding to database.

 * Renamed \dtl@columnindex to \dtlcolumnindex so that it can be
   used in the document.

 * Spaces may now occur after commas (but not before) in the 
   assignment part of \DTLforeach

 * Fixed missing backslashes in example in manual (pounds->\pounds)

 * Fixed type in datapie documentation: non-colour option is
   "gray" not "monochrome".

 * Added package "person.sty"

v2.02 (2009/07/13):
 * fixed bug caused by undefined \@dtlifhaskey (should be 
   \@DTLifhaskey)
 * fixed bug caused by undefined \dtl@getcolumnindex (should
   be \@dtl@getcolumnindex)
 * fixed bug in \DTLsavedb that ignores the file name

v2.01 (2009/03/27):
 * fixed bug that ignores descending sort option

v2.0 (2009/02/27):
 datatool.sty:

 * Rewritten database internal representation to make the code
   faster (thanks to Morten H\o gholm for this)
 * added etex as a required package
 * Database columns can now have an associated header (in addition
   to the key)
 * added \DTLdisplaydb and \DTLdisplaylongdb
 * added \DTLremoverow
 * \DTLloaddb, \DTLloadrawdb:
     - removed unnecessary checks to determine if database 
       exists when adding entries.
     - added optional argument
     - can now also load files without header row
 * \DTLsumforkeys, \DTLmeanforkeys, \DTLvarianceforkeys,
   \DTLsdforkeys, \DTLminforkeys and \DTLmaxforkeys now have a 
   second optional argument
 * added \DTLsumcolumn, \DTLmeanforcolumn, \DTLvarianceforcolumn,
   \DTLsdforcolumn, \DTLminforcolumn and \DTLmaxforcolumn
 * added \dtlforeachkey
 * added \dtlforint and \dtlgforint
 * added \dtlforcolumn and \dtlforcolumnidx
 * added \DTLcolumncount
 * added starred versions of:
   - \DTLifdbempty
   - \DTLnewrow
 * added \DTLifhaskey
 * added \DTLgetcolumnindex
 * added \DTLunsettype, \DTLstringtype, \DTLinttype, \DTLrealtype
   and \DTLcurrencytype
 * added \DTLgetdatatype 
 * removed \@dtl@setidtype
 * removed \@dtl@setkeys
 * removed \@dtl@getidtype
 * removed \@dtl@ifrowcontains
 * removed \dtl@getentryvalue
 * removed \dtl@getentryid
 * added \dtlgetentryfromcurrentrow
 * added \dtlforcolumnindex

 dataplot.sty
 * fixed bug causing ! Argument of \pgfmath@afterquick has an extra }
   error

 databar.sty
 * added \DTLeverybarhook

v1.01 (2007/08/17) :
 * Added databib package.

 * datatool.sty:

   - Fixed bug in datatool caused when certain commands occur
     in database entries or when the data type is tested.
   - Fixed bug in \DTLsubstituteall (caused problems when certain
   - commands occurred in string)
   - Added \DTLsplitstring
   - Added \DTLifSubString and \DTLisSubString
   - Added \DTLifStartsWith and \DTLisPrefix
   - Added case insensitive string tests
   - \DTLinitials and \DTLstoreinitials now work with ~ and \space
   - \DTLinitials and \DTLstoreinitials now use \DTLinitialhyphen
   - Added \dtlcompare (no longer using compare.tex)
   - Added \DTLgetvalueforkey
   - Added \DTLgetrowforkey
   - Added optional argument to \DTLsort
   - Fixed bug causing expansion in \DTLsort
   - Fixed bug in \DTLsdforall and \DTLvarianceforall
   - Removed extraneous spaces in \DTLaddall, \DTLminall, 
     \DTLmaxall, \DTLmeanforall, \DTLsdforall and \DTLvarianceforall
   - Fixed bug in \DTLiflastrow
   - Fixed bug in \DTLremovecurrentrow

 * Manual:
   - added code that produces fig "Student Marks (with average scores".
   - fixed typos in examples "Editing Database Rows" & "Mail Merging"
   - added section on null values

v1.0 (2007/07/23) : Initial Release
